// About.java
/* A Java class for
 * LineImpedance.java
 * Electromagnetic Transmission Line Applet
 * Applet without Smith Chart - Prepared by Umberto Ravaioli 
 * for 6th edition of Fundamentals of Applied Electromagnetics Book
 * May 2009 - All Rights Reserved
 */   


import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.*;
import java.net.URL;
import java.text.*;
import java.util.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.jar.Attributes;


public class Instructions extends Panel {
    
    private static final Color bgcolor = new Color(255,255,250);
    //private static final Color bgcolor = Color.white;
    
    public TextField epsilon;
    private Paint paint;
    
    private Image im;
    private Graphics buf;
    public Button bupdate;
    
    Trans_State state;
  
    public Instructions(Trans_State state){
	super();
        this.state = state;
	setLayout(null);
	setBackground(bgcolor);
        
        // update button
	bupdate = new Button("CLOSE");
        bupdate.setBackground(new Color(255,255,250));
	add(bupdate);
        int buttonx = 580;
        int buttony = 240;
        int buttonwide = 70;
        int buttonheight = 27;
        
        bupdate.setBounds(buttonx,buttony,buttonwide,buttonheight);	
        Panel ps7 = new Panel();
	    ps7.setBackground(Color.lightGray);
            // CHANGE ==========================================================
	    add(ps7);
            //==================================================================
	    ps7.setBounds(buttonx-1,buttony-1,buttonwide+2,buttonheight+2);
	    
	Panel ps8 = new Panel();
	    ps8.setBackground(Color.black);
	    // CHANGE ==========================================================
	    add(ps8);
	    //==================================================================
            ps8.setBounds(buttonx-2,buttony-2,buttonwide+4,buttonheight+4);
	
    }
    
    public void paint(Graphics g){
            
	    if(im == null){
		im = createImage(getSize().width,getSize().height);
		buf = im.getGraphics();
		drawCanvas(buf);
	    }
	    else{
		drawCanvas(buf);
	    }
	    g.drawImage(im,0,0,null);
    }
	
	//Addition to reduce flicker new routine
    public void update(Graphics g){		// added to avoid clearing
            paint(g);
    }
    
    public void clear(){
	    this.getGraphics().clearRect(0,0,getSize().width,getSize().height);
	    repaint();
    }
    
    public void drawCanvas(Graphics g){
        FontMetrics fm;
        Graphics2D g2d = (Graphics2D)g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON);        
        g.clearRect(0,0,getSize().width-1,getSize().height-1);

        //g.setFont(font_one);
        //fm = g.getFontMetrics();

        boolean saveOldFlag = MaestroG.useBiggerFont;
        MaestroG.useBiggerFont = false;
        
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,16f));
        g.setFont(new Font("SanSerif",Font.BOLD,16));
        //g.setFont(TheFonts.bold16);
        
        int deltaY = 27; int startx = 400; int ytitle = 30; int starty = 60;
        
        g.drawString("Instructions", 20,25);
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));
        //g.setFont(TheFonts.bold14);
        g.drawString("Input", 25,50);
        g.drawString("Displayed Information", startx,ytitle);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        //g.setFont(TheFonts.sanSerif14);
        
        //INPUT
        g.drawString("Characteristic impedance", 25,80);
        g.drawString("Load Impedance", 25,80+deltaY);
        g.drawString("Generator Voltage and Impedance",25,80+2*deltaY);
        
        //OUTPUT
        g.drawString("\u0393 = reflection coefficient @ load", startx,starty);
        MaestroG.subscripter("\u0393","d"," = \u0393 exp(-j2\u03b2d)"+
                             ", phase-shifted reflection coefficient at cursor",
                             g,14,startx,starty+deltaY);
        MaestroG.subscripterWavy("V","","(d) = total phasor voltage",
                                 g,14,startx,starty+2*deltaY);
        MaestroG.subscripterWavy(" I","","(d) = total phasor current",
                                 g,14,startx,starty+3*deltaY);
        g.drawString("Plots: |",startx,starty+4*deltaY);
        fm = g.getFontMetrics();
        int x = startx + fm.stringWidth("Plots: |");
        MaestroG.subscripterWavy("V","","(d)|, |",g,14,x,starty+4*deltaY);
        x += fm.stringWidth("V(d)|, |");
        MaestroG.subscripterWavy(" I","","(d)|, v(d,t),",g,14,x,starty+4*deltaY);
        g.drawString("        i(d,t), Z(d), p(d,t)",startx,starty+5*deltaY);

        drawCopyRight(g);

        MaestroG.useBiggerFont = saveOldFlag;

    }

    public void drawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 70;
        int startingX = 0;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        g.setFont(state.ttfFont.deriveFont(14f));
        fm = g.getFontMetrics();
        g.drawString("Applet Design: Umberto Ravaioli",
                     startingX+15,startingY+deltaY);
        
        MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
                               g,14,startingX+15,startingY+2*deltaY);
        int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        lineLength += 10;

        g.setFont(state.ttfFont.deriveFont(14f));
        g.drawString("All Rights Reserved",startingX+15,startingY+3*deltaY);
        g.drawLine(startingX,startingY,
                   startingX+lineLength+25,startingY);
        g.drawLine(startingX+lineLength+25,startingY,
                   startingX+lineLength+25,startingY+4*deltaY);
    }

//----------------------------------------------------------------------------------------    
}//End
    

